package com.wwj.sb.custom;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import android.util.Xml.Encoding;
import android.widget.SlidingDrawer;

import com.wwj.sb.domain.LrcContent;

/**
 * 2013/6/1
 * @author	wwj
 *	ʵ
 */
public class LrcProcess {
	private List<LrcContent> lrcList;	//ListϴŸݶ
	private LrcContent mLrcContent;		//һݶ
	/**
	 * ޲ι캯ʵ
	 */
	public LrcProcess() {
		mLrcContent = new LrcContent();
		lrcList = new ArrayList<LrcContent>();
	}
	
	/**
	 * ȡ
	 * @param path
	 * @return
	 */
	public String readLRC(String path) {
		//һStringBuilderŸ
		StringBuilder stringBuilder = new StringBuilder();
		File f = new File(path.replace(".mp3", ".lrc"));
		
		try {
			//һļ
			FileInputStream fis = new FileInputStream(f);
			InputStreamReader isr = new InputStreamReader(fis, "utf-8");
			BufferedReader br = new BufferedReader(isr);
			String s = "";
			while((s = br.readLine()) != null) {
				//滻ַ
				s = s.replace("[", "");
				s = s.replace("]", "@");
				
				//롰@ַ
				String splitLrcData[] = s.split("@");
				if(splitLrcData.length > 1) {
					mLrcContent.setLrcStr(splitLrcData[1]);
					
					//ȡøʱ
					int lrcTime = time2Str(splitLrcData[0]);
					
					mLrcContent.setLrcTime(lrcTime);
					
					//ӽб
					lrcList.add(mLrcContent);
					
					//´ݶ
					mLrcContent = new LrcContent();
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			stringBuilder.append("ľиļϽȥأ...");
		} catch (IOException e) {
			e.printStackTrace();
			stringBuilder.append("ľжȡŶ");
		}
		return stringBuilder.toString();
	}
	/**
	 * ʱ
	 * ݸʽ£
	 * [00:02.32]Ѹ
	 * [00:03.43]þò
	 * [00:05.22]  
	 * @param timeStr
	 * @return
	 */
	public int time2Str(String timeStr) {
		timeStr = timeStr.replace(":", ".");
		timeStr = timeStr.replace(".", "@");
		
		String timeData[] = timeStr.split("@");	//ʱַָ
		
		//֡벢תΪ
		int minute = Integer.parseInt(timeData[0]);
		int second = Integer.parseInt(timeData[1]);
		int millisecond = Integer.parseInt(timeData[2]);
		
		//һһеʱתΪ
		int currentTime = (minute * 60 + second) * 1000 + millisecond * 10;
		return currentTime;
	}
	public List<LrcContent> getLrcList() {
		return lrcList;
	}
}
